var mc = require('mongodb').MongoClient;
var playersCollection, roomsCollection;
var defaultRoom = {   name: "theVoid",
                      title: "The Void",
                      description: "You are in the Void.  " +
                      "How did you get here?  There are no exits.",
                      roomExits: ['theVoid']
                  };
exports.connectToDBs = function() {
    mc.connect('mongodb://localhost/adventure-demo', function(err, db) {
        playersCollection = db.collection('players');
        roomsCollection = db.collection('rooms');
    });
}
var savePlayer = function(player) {
    var errorHandler = function(err, count) {
        if (err) {
            console.log("Couldn't save player state");
        }
    }
    playersCollection.update({"playername": player.playername},
                             player, errorHandler);
}
exports.index = function(req, res) {
    res.render('index', { title: 'COMP 2406 Simple Adventure', 
                          error: req.query.error });
}
exports.register = function(req, res) {
    var playername = req.body.playername;
    var password = req.body.password;
    var addPlayer = function(err, players) {
        if (players.length!=0) {
            res.redirect("/?error=player already exists");      
            return;
        }
        var newPlayer = {
            playername: playername,
            password: password,
            room: "bridge"
        };
        playersCollection.insert(newPlayer, function(err, newPlayers){
            res.render('registered', 
                       { playername: newPlayers[0].playername });
        });    
    };  
    playersCollection.find({playername: playername}).toArray(addPlayer);
}
exports.start = function(req, res){
    var playername = req.body.playername;
    var password = req.body.password;

    playersCollection.findOne({playername: playername}, function(err, player){
        if (err || !player || password !== player.password){
            req.session.destroy(function(err) {
                res.redirect("/?error=invalid playername or password"); 
            });
            return;
        } else {
            
            req.session.player = player;
            delete req.session.player._id;
            res.redirect("/game");
        }
    });
}
exports.quit = function(req, res){
    req.session.destroy(function(err){
        if (err) {
            console.log("Error: %s", err);
        }
        res.redirect("/");
    }); 
}
exports.game = function(req, res) {
    if (req.session.player) {
        res.render("room.jade", {title: "AJAX Adventure Demo"});
    } else {
        res.redirect("/");
    }
}
exports.doAction = function(req, res) {
    var action = req.body.action;
    var room = req.body.room;

    if (!req.session.player) {
        res.send("Error: NotLoggedIn");
        return;
    }

    if (action === "move") {
        req.session.player.room = room;
        savePlayer(req.session.player);
        res.send("Success");
    } else {
        res.send("Error: InvalidAction");
    }
}
exports.getContents = function(req, res) {    
    if (!req.session.player) {
        res.send("Error: NotLoggedIn");
        return;
    }
    
    roomsCollection.findOne(
        {name: req.session.player.room},
        function(err, room) {
            if (err || !room) {
                room = defaultRoom;
            }
            res.send(room);
        }
    );
}
